//-----------------------------------------------------
//	DirectX Q[vO~OTv
//
//	FPS\
//
//	2010.03.16 TMO
//-----------------------------------------------------
#include "stdafx.h"
#include "myapp.h"

FPSDisplay::FPSDisplay()
{
	m_FPSCounter	= 0;
	m_workFPS		= 0;

	m_FPS			= 0;
	m_DropCount		= 0;

	m_active = true;
}

void FPSDisplay::Create()
{
	//tHg̏
	LOGFONT	logFont;
	::ZeroMemory( &logFont, sizeof( logFont ) );
	logFont.lfHeight = 10;	//tHgTCY
	logFont.lfWidth = 0;
	logFont.lfEscapement = 0;
	logFont.lfOrientation = 0;
	logFont.lfWeight = FW_EXTRABOLD;
	logFont.lfItalic = 0;
	logFont.lfUnderline = 0;
	logFont.lfStrikeOut = 0;
	logFont.lfCharSet   = SHIFTJIS_CHARSET;
	logFont.lfOutPrecision = OUT_TT_ONLY_PRECIS;
	logFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
	logFont.lfQuality = PROOF_QUALITY;
	logFont.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;
	wcscpy_s( logFont.lfFaceName, LF_FACESIZE, _T("lr SVbN") );//͕(obt@TCYƃfobKIȂ肷)
	
	//FPS\eNX`
	m_txtFPS.Create(_T("FPS ="),0,0, 100, 10, logFont );
	m_txtFPS.SetTextAlpha(0xffffffff);
	
	m_txtDrop.Create(_T("DropFrame ="),0, 15, 100, 30, logFont );
	m_txtDrop.SetTextAlpha(0xffffffff);

	WCHAR wc[10];
	for ( int c = 0; c <10; c++ ) {
		wsprintf( wc, _T("%d"),c );
		m_txtNumbers[c].Create( wc,  0,0, 50, 50, logFont );
		m_txtNumbers[c].SetTextAlpha(0xffffffff);
	}
}

void FPSDisplay::CountFPS( double pathtime ) {
	m_workFPS += pathtime;
	m_FPSCounter++;
	if ( m_FPSCounter >= FPS_COUNTERMAX ) {
		
		m_FPS = int( ( 1.0 / (m_workFPS / (double)FPS_COUNTERMAX) ) + 0.5 );//0.5ƂŎľܓł܂
		//m_FPS = int( ( 1.0 / (m_workFPS / (double)FPS_COUNTERMAX) ) * 10 );//_ȉȂ炱ŁB

		m_workFPS = 0;
		m_FPSCounter = 0;
	}

}

//l̕`
void FPSDisplay::DrawCounter( int count, int right, int top )
{
	int wCount = count;
	int pos = right;
	do {
		
		int idx = wCount %10;
		m_txtNumbers[ idx ];
		wCount /= 10;
		m_txtNumbers[idx].SetPos( pos, top );
		m_txtNumbers[idx].Draw();
		pos-=15;

	} while ( wCount != 0 );

}

void FPSDisplay::Draw()
{
	if ( !m_active ) { return; }

	GetGraphic()->DrawColorRect(0,0,640,30,0xaa000000);

	//FPS
	m_txtFPS.Draw();
	DrawCounter( m_FPS, 200, 0);

	//t[
	m_txtDrop.Draw();
	DrawCounter( m_DropCount, 200, 15);
}

void FPSDisplay::Release()
{
	m_txtFPS.Release();
	for ( int c = 0; c <10; c++ ) {
		m_txtNumbers[c].Release();
	}
}