//-----------------------------------------------------
//	DirectX Q[vO~OTv
//
//	Av̖{̃NX
//
//	2010.03.16 TMO
//-----------------------------------------------------
#include "..\LibGraphic\Graphic.h"
#include "..\LibInput\Input.h"

//vC[AGȂ
class Actor
{
	XFileObject* m_model;

public:
	float x;
	float y;
	float z;

	float rot_y;	//xNg̉]p

	//Xt@C֘AÂ
	void Attuch(XFileObject* model);
	//Oֈړ
	void MoveFront(float val);
	//`
	void Draw();
};

//FPS\NX
//60񕪂̍XVWvĕςƂ̂Aľܓl\܂B
class FPSDisplay
{
	#define FPS_COUNTERMAX 60

	TextGraphic	m_txtFPS;
	TextGraphic	m_txtDrop;
	TextGraphic	m_txtNumbers[10];

	int m_FPSCounter;	//̍XV畽ςĂ

	void DrawCounter( int count, int right, int top );

public:
	FPSDisplay();

	int  m_FPS;
	double m_workFPS;
	int  m_DropCount;	//t[
	bool m_active;

	void Create();

	//FPSWv
	void CountFPS( double pathtime );//ɑOJEǧoߎ

	void Draw();
	void Release();
};


class MyApp
{
private:
	HWND		m_hWnd;

	FPSDisplay	m_fpsDisp;//FPS\

	//--------------------------
	//t[
	double	m_FPS;
	bool	m_suportDropFrames;
	double	m_elapsed;
	double	m_elapsed_FPS;
	LARGE_INTEGER	m_lastPerfCounter;
	DWORD			m_lastTickCount;
	//--------------------------

public:
	CTexture	m_backImage;
	TextGraphic m_text;		//eNX`摜eLXgf[^

	Actor		m_player;
	
	XFileObject	m_playerXFile;
	XFileObject	m_map;
	
	Camera		m_cam;

public:
	MyApp() {
		m_elapsed		= 0;
		m_elapsed_FPS	= 0;
	}

	//TvAv̏
	void Init(HWND hWnd);

	//t[p̃JE^Zbg
	void CounterReset() {
		LARGE_INTEGER freq, count;
		DWORD tick;
		if ( QueryPerformanceFrequency(&freq) && 
			QueryPerformanceCounter(&count) ) {
			m_lastPerfCounter=count;
		} else {
			tick=GetTickCount();
			m_lastTickCount=tick;
		}
	}
	
	void Draw();
	void Move();
	void Roop();

	//TvAv̉
	void Release();

};

extern MyApp* GetApp();
