//-----------------------------------------------------
//	`֘ACu
//	eLXg摜̍쐬A`Ȃ
//	2010.03.04 TMO
//-----------------------------------------------------

#include "stdafx.h"
#include "Graphic.h"

//쐬ꂽD3DfoCX擾
extern LPDIRECT3DDEVICE9 GetDevice();

//P̃eLXg`eNX`쐬
void CreateTxtureChar( LPDIRECT3DTEXTURE9* pTexGet, int* pTexWidGet, TCHAR *c,  HFONT hFont, DWORD basecolor )
{
	LPDIRECT3DTEXTURE9	pTex	= NULL;
	BYTE*				ptr		= NULL;

	try {

		HDC		hdc		= GetDC(NULL);
		HFONT	oldFont	= (HFONT)SelectObject( hdc, hFont );
		UINT	code	= (UINT)( *c );

		//tHgrbg}bv擾
		TEXTMETRIC TM;
		GetTextMetrics( hdc, &TM );
		GLYPHMETRICS GM;
		CONST MAT2 Mat = {{0,1},{0,0},{0,0},{0,1}};
		DWORD size = GetGlyphOutline( hdc, code, GGO_GRAY4_BITMAP, &GM, 0, NULL, &Mat );
		ptr = new BYTE[size];

		if ( GDI_ERROR == GetGlyphOutline( hdc, code, GGO_GRAY4_BITMAP, &GM, size, ptr, &Mat ) ) {
			throw;
		}
		
		SelectObject( hdc, oldFont );
		ReleaseDC( NULL, hdc );

		//eNX`쐬
		//ɗ]̂ŁAeNX`TCY̓tHgTCYƈقȂB
		if ( FAILED( GetDevice()->CreateTexture( GM.gmCellIncX, TM.tmHeight, 1, D3DUSAGE_DYNAMIC, D3DFMT_A8R8G8B8, D3DPOOL_DEFAULT, &pTex, NULL ) ) ) {
		   if ( FAILED( GetDevice()->CreateTexture( GM.gmCellIncX, TM.tmHeight, 1, 0, D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, &pTex, NULL ) ) ) {
			   throw;
		   }
		}

		D3DLOCKED_RECT LockedRect;
		if ( FAILED( pTex->LockRect( 0, &LockedRect, NULL, D3DLOCK_DISCARD ) ) ) {
			if ( FAILED( pTex->LockRect(0, &LockedRect, NULL, 0 ) ) ) {
				throw;
			}
		}

		//NA
		ZeroMemory( LockedRect.pBits , LockedRect.Pitch * TM.tmHeight );

		//tHgrbg}bv̕
		int bmp_w = GM.gmBlackBoxX;
		int bmp_h = GM.gmBlackBoxY;
		//ۂɊmۂĂrbg}bv̕(4̔{ɂȂĂ)
		int bmp_pitch = GM.gmBlackBoxX + ( 4 - ( GM.gmBlackBoxX % 4 ) ) % 4;

		//̈ʒu
		int ofs_x = GM.gmptGlyphOrigin.x;				
		int ofs_y = TM.tmAscent - GM.gmptGlyphOrigin.y;

		int px, py;
		DWORD Alpha, Color;

		for ( py = ofs_y; py < ofs_y + bmp_h; py++ ) {
			for ( px = ofs_x; px < ofs_x + bmp_w; px++ ) {
				//At@lłGGO_GRAY4_BITMAP17K(0`16)Ȃ̂16Ŋ
				Alpha = (255 * ptr[px-ofs_x + bmp_pitch*(py-ofs_y)]) >> 4;

				Color = basecolor | (Alpha << 24);

				memcpy( (BYTE*)LockedRect.pBits + LockedRect.Pitch*py + 4*px, &Color, sizeof( DWORD ) );
			}
		}
		pTex->UnlockRect(0);


		*pTexGet	= pTex;
		*pTexWidGet	= GM.gmCellIncX;//GM.gmCellIncX͎w肵tHgTCYʂɂȂȂ̂ŁAʂɊoĂB

		//emF ߂ŕĂ̂pngŕۑ
		//D3DXSaveTextureToFileW(TEXT("c:\\test.png"),D3DXIFF_PNG, pTex, NULL);

	} catch(...) {
		if ( pTex ) {
			pTex->Release();
		}
	}

	if ( ptr ) {
		delete[] ptr;
	}

}

TextuteTextLine::TextuteTextLine()
{
	m_align = AlignLeft;
	m_lineWidth = 0;
}

TextuteTextLine::~TextuteTextLine()
{
}


TextGraphic::TextGraphic()
{
	m_rect		= IRECT(0,0,0,0);
	m_fontsize	= 10;
	m_alphaColor= 0xffffffff;
}

TextGraphic::~TextGraphic()
{
	Release();
}

void TextGraphic::Release()
{
	for ( std::vector< TextuteTextLine* >::iterator it = m_lineAry.begin(); it != m_lineAry.end(); it++ ) {

		std::vector<TxtureChar>::iterator it_char = (*it)->begin();
		for ( ; it_char != (*it)->end(); it_char++ ) {
			(*it_char).m_txtr->Release();
		}
		(*it)->clear();

		delete (*it);
	}
	m_lineAry.clear();

}

void TextGraphic::Create( LPCTSTR txt, int left, int top, int right, int bottom, LOGFONT& logFont )
{
	Release();

	m_rect.left   = left;
	m_rect.top    = top;
	m_rect.right  = right;
	m_rect.bottom = bottom;

	m_fontsize = logFont.lfHeight;
	
	HFONT hFont = CreateFontIndirect( &logFont );
	if( !hFont ) { return; }

	TCHAR* t = (TCHAR*)txt;

	TextuteTextLine* addLine = new TextuteTextLine();

	TxtureChar add;

	for ( unsigned int c= 0; c < wcslen(txt); c++ )  {

		if ( *t == TEXT('\n') ) {

			m_lineAry.push_back( addLine );
			addLine = new TextuteTextLine();

			t++;
			continue;
		}
		
		//F͔ōĂ܂BFƃ|SDiffuseFŔF̂𑀍ł܂B
		CreateTxtureChar( &add.m_txtr, &add.m_wid, t, hFont, 0x00ffffff );
		if ( addLine->m_lineWidth + add.m_wid > m_rect.Wid() ) {
			//܂Ԃ
			m_lineAry.push_back( addLine );
			addLine = new TextuteTextLine();
		}

		addLine->push_back(add);
		addLine->m_lineWidth += add.m_wid;
		t++;
	}

	if ( addLine->size() ) {
		m_lineAry.push_back( addLine );
	} else {
		delete addLine;
	}

	DeleteObject( hFont );

}

//s낦̎w(Ss)
void TextGraphic::SetTextAlign( TextAlign align )
{
	if ( m_lineAry.size() < 0 ){return;}
	
	for ( unsigned int c = 0; c <= m_lineAry.size()-1; c++ ) {
		m_lineAry[c]->m_align = align;
	}
}

//s낦̎w(Cӂ̕s)
void TextGraphic::SetTextAlign(
	unsigned int lineIdx,	//Jnʒu
	unsigned int lineIdxTo,	//Iʒu
	TextAlign align )
{
	if ( m_lineAry.size() >= lineIdx ) {
		return;
	}
	if ( m_lineAry.size() >= lineIdxTo ) {
		return;
	}
	for ( unsigned int c = lineIdx; c <= lineIdxTo; c++ ) {
		m_lineAry[c]->m_align = align;
	}
}

//eLXg̃At@l(`悷|SDiffuseF)ύX
void TextGraphic::SetTextAlpha(DWORD alpha)
{
	m_alphaColor = alpha;
}

void TextGraphic::Draw()
{
	int st_x = m_rect.left;
	int st_y = m_rect.top;

	int cellwid;

	for ( std::vector< TextuteTextLine* >::iterator it = m_lineAry.begin(); it != m_lineAry.end(); it++ ) {
		st_x = m_rect.left;
		
		switch ( (*it)->m_align ) {
			case TextAlign::AlignLeft:
				break;
			case TextAlign::AlignRight:
				st_x += ( m_rect.Wid() - (*it)->m_lineWidth );
				break;
			case TextAlign::AlignCenter:
				st_x += ( m_rect.Wid() - (*it)->m_lineWidth ) >> 1;
				break;
		}

		for ( std::vector<TxtureChar>::iterator it2 = (*it)->begin(); it2 != (*it)->end(); it2++ ) {

			GetDevice()->SetTexture(0, (*it2).m_txtr );
			
			cellwid = (*it2).m_wid;
			GetGraphic()->Draw( (float)st_x, (float)st_y, (float)( st_x+cellwid ), (float)( st_y+m_fontsize ), m_alphaColor );
			st_x+=cellwid;

		}
		st_y += m_fontsize;
	}

}