//-----------------------------------------------------
//	`֘ACu
//	`
//	2010.03.16 TMO
//-----------------------------------------------------
#include "stdafx.h"
#include "Graphic.h"

extern LPDIRECT3DDEVICE9 GetDevice();

//`OɌĂ
void CGraphic::ClearAndBegin()
{
	//ʃNA
	GetDevice()->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, m_backColor, 1.0f, 0 );

	//foCXɕ`Jnm点
	HRESULT hr;
	hr = GetDevice()->BeginScene();
}

//`ɌĂ
void CGraphic::EndAndPresent()
{
	//foCXɕ`Im点
	GetDevice()->EndScene();
	
	//ʂobNobt@ƓւB
	GetDevice()->Present( NULL, NULL, NULL, NULL );
}

//F̓``Bł܂B/Ŝ̃tF[hɎg
void CGraphic::DrawColorRect( float left, float top, float right, float bottom, DWORD color )
{
	D3DVERTEX *d3dv;
	m_pVB->Lock(0 , 0 , (void**)&d3dv , 0);
	d3dv[0].pos.x = left;
	d3dv[0].pos.y = top;
	d3dv[0].pos.z = 0;
	d3dv[0].rhw = 1;
	d3dv[0].color = color;
	d3dv[0].tu = 0.0f;
	d3dv[0].tv = 0.0f;

	d3dv[1] = d3dv[0];
	d3dv[1].pos.x = right;
	d3dv[1].pos.y = top;
	d3dv[1].tu = 1.0f;
	d3dv[1].tv = 0.0f;

	d3dv[2] = d3dv[0];
	d3dv[2].pos.x = left;
	d3dv[2].pos.y = bottom;
	d3dv[2].tu = 0.0f;
	d3dv[2].tv = 1.0f;

	d3dv[3] = d3dv[0];
	d3dv[3].pos.x = right;
	d3dv[3].pos.y = bottom;
	d3dv[3].tu = 1.0f;
	d3dv[3].tv = 1.0f;

	m_pVB->Unlock();
	
	GetDevice()->SetTexture(0, NULL);
	GetDevice()->SetVertexShader(NULL);
	GetDevice()->SetFVF( D3DFVF_2DVERTEX );
	GetDevice()->SetStreamSource( 0, m_pVB, 0, sizeof(D3DVERTEX) );
	GetDevice()->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2);

}

//`
void CGraphic::Draw( float left, float top, float right, float bottom, DWORD alphaColor )
{
	//wʒû܂܂ŕ`ƃ|S̋Eł킸Ȃꂪ܂B_gpĂ邽߂ƂEEEB
	//_W炷Ƃłꂢɕ`B
	left	-= 0.5f;
	top		-= 0.5f;
	right	-= 0.5f;
	bottom	-= 0.5f;

	D3DVERTEX *d3dv;
	m_pVB->Lock(0 , 0 , (void**)&d3dv , 0);
	d3dv[0].pos.x = left;
	d3dv[0].pos.y = top;
	d3dv[0].pos.z = 0;
	d3dv[0].rhw = 1;
	d3dv[0].color = alphaColor;
	d3dv[0].tu = 0.0f;
	d3dv[0].tv = 0.0f;

	d3dv[1] = d3dv[0];
	d3dv[1].pos.x = right;
	d3dv[1].pos.y = top;
	d3dv[1].tu = 1.0f;
	d3dv[1].tv = 0.0f;

	d3dv[2] = d3dv[0];
	d3dv[2].pos.x = left;
	d3dv[2].pos.y = bottom;
	d3dv[2].tu = 0.0f;
	d3dv[2].tv = 1.0f;

	d3dv[3] = d3dv[0];
	d3dv[3].pos.x = right;
	d3dv[3].pos.y = bottom;
	d3dv[3].tu = 1.0f;
	d3dv[3].tv = 1.0f;

	m_pVB->Unlock();
	
	GetDevice()->SetVertexShader(NULL);
	GetDevice()->SetFVF( D3DFVF_2DVERTEX );
	GetDevice()->SetStreamSource( 0, m_pVB, 0, sizeof(D3DVERTEX) );
	GetDevice()->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2);
}

void CGraphic::Draw( float left, float top, float right, float bottom, CTexture* texture, DWORD alphaColor )
{
	texture->SetCurrentUse();
	Draw( left, top, right, bottom, alphaColor );
}