#pragma once
//-----------------------------------------------------
//	̓Cu
//	2009.12.29 TMO
//-----------------------------------------------------

#include "input.h"

//L[{[h
class CInputKeyboard
{

	IDirectInputDevice8*	m_pDIDevKB;			//foCX
	bool					m_Keystate[256];	//XVɉĂON(ςȂE)
	bool					m_KeyAction[256];	//ゾON(ςȂOFFɂȂ)
												//zCfbNXDIK_SPACEȂ

public:
	CInputKeyboard();
	bool Create( IDirectInput8* pDInput, HWND hWnd );
	void Release();
	void Update();

	bool ChkKeyDown(   int key ) { return m_Keystate[key]; }
	bool ChkKeyAction( int key ) { return m_KeyAction[key]; }
};

//}EX
class CInputMouse
{
	IDirectInputDevice8*	m_pDIMouse;		//foCX
	bool CreateMouse();
	void UpdateInput_Mouse();
	void ReleaseMouse();

	HWND					m_hWnd;
	int						m_wndWid;
	int						m_wndHgt;
	bool					m_windowMode;

	long					m_posX;	//}EXW
	long					m_posY;

	bool					m_LDown;	//Update_̃{^
	bool					m_RDown;
	bool					m_MDown;
	
	bool					m_LAction;	//{^ゾONɂȂ(NbNEƂ)
	bool					m_RAction;
	bool					m_MAction;

public:

	CInputMouse();
	bool Create( IDirectInput8* pDInput, HWND hWnd );
	void Release();
	void Update();

	long PosX() { return m_posX; }
	long PosY() { return m_posY; }
	bool IsLDown(){return m_LDown;}
	bool IsRDown(){return m_RDown;}
	bool IsMDown(){return m_MDown;}
	bool IsLAction(){return m_LAction;}
	bool IsRAction(){return m_RAction;}
	bool IsMAction(){return m_MAction;}
	
	//EBhE[h̎w
	//J[\ʒuAPI邩ADirectInput邩̔fɗp
	void SetWindowMode( bool isWindowmode )	{ m_windowMode = isWindowmode; }//true:EBhE[h false:tXN[

	void OperateMouseMessage( UINT message, WPARAM wParam, LPARAM lParam )
	{
		if ( !m_windowMode ) {
			return;
		}
		
		if ( message == WM_MOUSEMOVE ) {
			SetCursorPos( LOWORD(lParam), HIWORD(lParam) );
		}
	}

	void SetCursorPos( int x, int y )
	{
		m_posX = x;
		m_posY = y;
	}

};

//Q[pbh---------------------------------
//(\L[ƂS̃{^)
class CInputGamepad
{
	IDirectInputDevice8*	m_pDIDevJS;			//foCX
	bool					gamepadState[8];	//XVɉĂON
	bool					gamepadAction[8];	//ĎXV܂ON
				/*
				#define GamePadBtn_UP		0
				#define GamePadBtn_DOWN		1
				#define GamePadBtn_LEFT		2
				#define GamePadBtn_RIGHT	3
				#define GamePadBtn_Btn0		4
				#define GamePadBtn_Btn1		5
				#define GamePadBtn_Btn2		6
				#define GamePadBtn_Btn3		7
				*/
public:
	CInputGamepad();
	bool Create( IDirectInput8* pDInput, HWND hWnd );
	void Release();
	void Update();

	bool ChkGamePadDown(int btn) { return gamepadState[btn]; }
	bool ChkGamePadAction(int btn) { return gamepadAction[btn]; }

};